public static class GameConstants
{
    public static class PlayerPrefsKeys
    {
        #region PlayerPrefs Keys

        public static string CharacterDataKey = "characterData";
        public static string CharacterInventoryDataKey = "characterInventoryData";
        public static string CharacterEquipmentDataKey = "characterEquipmentData";
        public static string PlayerCoinKey = "playerCoin";

        public static string GetCharacterDataKey(string characterName)
        {
            return CharacterDataKey + "-" + characterName;
        }
        public static string GetCharacterInventoryDataKey(string characterName)
        {
            return CharacterInventoryDataKey + "-" + characterName;
        }
        public static string GetCharacterEquipmentDataKey(string characterName)
        {
            return CharacterEquipmentDataKey + "-" + characterName;
        }
        public static string GetPlayerCoinKey(string playerName)
        {
            return PlayerCoinKey + "-" + playerName;
        }

        #endregion
    }


    public static class ObjectSources
    {
        #region Object Sources (example stat increase source)

        public static object AllocatedSource = "Allocated";
        public static object LevelSource = "Level";

        #endregion
    }

    public static class NetworkEventCodes
    {
        #region Network Event Codes

        public static byte JobSelection = 112;
        public static byte CancelChangeLevelVoted = 114;
        public static byte ChangeLevelVoted = 115;
        public static byte LoadLevelStarting = 116;

        #endregion
    }

    public static class NetworkPropertyKeys
    {
        public static string AvailableJobsKey = "availableJobs";
    }

    public static class Sizes
    {
        public static int TotalEquipmentSlots = 6;
        public static int TotalInventorySlots = 18;
    }

}